'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Factory = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Statements = require('./Statements');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @private
 */
var Factory = exports.Factory = function () {

    /**
     * @param {ParserOptions} [options] the options
     */
    function Factory(options) {
        _classCallCheck(this, Factory);

        this.options = options;
        this.render = _Statements.Statements.get(this.options).append('var ' + (options.elVarName || 'el') + ' = __el__;').append('var ' + (options.ctxVarName || 'ctx') + ' = __ctx__;');
        this.wrapper = _Statements.Statements.get(this.options).append('var fcOpenElement = funclate.openElement;').append('var fcCloseElement = funclate.closeElement;').append('var fcVoidElement = funclate.voidElement;').append('var fcContent = funclate.content;').append('var fcText = funclate.text;').append('var fcComment = funclate.comment;');
    }

    _createClass(Factory, [{
        key: 'appendOpenElement',
        value: function appendOpenElement(name, attrs, props, opts) {
            this.render.append('fcOpenElement(\'' + name + '\', ' + attrs + ', ' + props + ', ' + opts + ');');
            return this;
        }
    }, {
        key: 'appendCloseElement',
        value: function appendCloseElement() {
            this.render.append('fcCloseElement();');
            return this;
        }
    }, {
        key: 'appendVoidElement',
        value: function appendVoidElement(name, attrs, props, opts) {
            this.render.append('fcVoidElement(\'' + name + '\', ' + attrs + ', ' + props + ', ' + opts + ');');
            return this;
        }
    }, {
        key: 'appendText',
        value: function appendText(text) {
            this.render.append('fcText(' + text + ');');
            return this;
        }
    }, {
        key: 'appendComment',
        value: function appendComment(text) {
            this.render.append('fcComment(' + text + ');');
            return this;
        }
    }, {
        key: 'appendContent',
        value: function appendContent() {
            this.render.append('fcContent();');
            return this;
        }
    }, {
        key: 'append',
        value: function append(statement) {
            this.render.append(statement);
            return this;
        }
    }, {
        key: 'toFunction',
        value: function toFunction() {
            var wrapper = this.wrapper.append('return function (__el__, __ctx__) {').append(this.render.join()).append('}').join();
            if (this.options.output === 'string') {
                return 'function (funclate) {' + wrapper + '}';
            }
            return new Function('funclate', wrapper);
        }
    }]);

    return Factory;
}();