"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Base class for funclate's tag implementations.
 * @abstract
 */
var FcTag = exports.FcTag = function () {
  function FcTag() {
    _classCallCheck(this, FcTag);
  }

  _createClass(FcTag, [{
    key: "startTag",

    /**
     * Invoked when starting tag of the element is found.
     * @param {!Factory} factory the factory
     * @param {!string} name the name
     * @param {!Map.<Attribute>} attributes the attributes
     * @param {boolean} selfClosing
     */
    value: function startTag(factory, name, attributes, selfClosing) {}

    /**
     * Invoked when ending tag of the element is found.
     * @param {!Factory} factory the factory
     * @param {!string} name the name
     */

  }, {
    key: "endTag",
    value: function endTag(factory, name) {}
  }]);

  return FcTag;
}();